(***********************************************************************)
(*                                                                     *)
(*            cast objet en O'Caml                                     *)
(*                                                                     *)
(*            Emmanuel Chailloux, Equipe PPS, universite P7            *)
(*                                                                     *)
(*                                                                     *)
(***********************************************************************)

(* $Id: cast.mli,v 1.2 2001/09/06 14:52:54 emmanuel Exp $ *)


type id = unit -> unit
exception Cast_failure of string * int * int
exception Forbidden_downcast  of string * int * int;;
exception Forbidden_upcast of string * int * int;;

val create_id : 'a -> id
val string_of_id : id -> string
val check : int * int -> < ___get_castable : bool; ___check_exact_id : id  -> bool; ___check_id : id  -> bool; .. > -> id -> id -> unit
val check_sonof :
  int * int -> < ___check_sonof : id -> id -> bool; .. > -> id -> id -> unit
val instanceof : int * int -> < ___check_id : id -> bool; .. > -> id -> bool
val check_from :
  int * int -> < ___check_from : id -> id -> bool; .. > -> id -> id -> unit
